import React from 'react';
import {
    View,
    Text,
    BackHandler,
    ImageBackground,
    Alert,
    Modal,
    StyleSheet,
    TouchableOpacity,
    PermissionsAndroid,
    Platform,
} from 'react-native';
import {
    check,
    PERMISSIONS,
    RESULTS,
    request,
    openSettings,
    requestNotifications,
    Permission,
    checkNotifications,
} from 'react-native-permissions';
import RNExitApp from 'react-native-exit-app';
import PushNotification from "react-native-push-notification";
import PushNotificationIOS from "@react-native-community/push-notification-ios";
import messaging from '@react-native-firebase/messaging';
import Firebase from '@react-native-firebase/app';

function backPressed() {
    console.log('back pressed');
    // BackHandler.exitApp();
    RNExitApp.exitApp();
    return true;
}
export default class GetNotification extends React.Component {
    constructor(props) {
        super(props)
        this.state = {
            modalVisible: false,
            deniedNotificationModalVisible: false
        }
    }

    showModal() {
        return (
            <Modal
                animationType="slide"
                transparent={true}
                visible={this.state.deniedNotificationModalVisible}
                onRequestClose={() => {
                    // Alert.alert('Modal has been closed.');
                    this.setState(
                        { deniedNotificationModalVisible: !this.state.deniedNotificationModalVisible }
                    );
                }}>
                <View style={styles.centeredView}>
                    <View style={styles.modalView}>
                        <View style={{ paddingHorizontal: 20, marginBottom: 20 }}>
                            <Text
                                style={{
                                    color: 'grey',
                                    textAlign: 'center',
                                    fontWeight: 'bold',
                                    // fontFamily: fonts.Futura_Book_Font,
                                    fontSize: 20,
                                    marginBottom: 10,
                                }}>
                                Notification Permission Denied
                  </Text>
                            <Text
                                style={{
                                    textAlign: 'center',
                                    color: 'grey',
                                    // fontFamily: fonts.Futura_Book_Font,
                                    fontSize: 16,
                                }}>
                                Turning on Notification Permission can help you keep up to date.
                  </Text>
                        </View>
                        <View
                            style={{
                                height: 0.5,
                                width: '100%',
                                backgroundColor: 'grey',
                                opacity: 0.2,
                            }}
                        />
                        <View
                            style={{
                                flexDirection: 'row',
                                height: 60,
                                width: '100%',
                                alignItems: 'center',
                                justifyContent: 'space-evenly',
                            }}>
                            <TouchableOpacity
                                onPress={() => {
                                    this.setState(
                                        { deniedNotificationModalVisible: !this.state.deniedNotificationModalVisible }
                                    );
                                    openSettings();
                                }}>
                                <Text style={{ color: 'blue' }}>Settings</Text>
                            </TouchableOpacity>
                            <View
                                style={{
                                    backgroundColor: 'grey',
                                    height: '100%',
                                    width: 1,
                                    opacity: 0.5,
                                }}
                            />
                            <TouchableOpacity
                                onPress={() => {
                                    this.setState(
                                        { deniedNotificationModalVisible: !this.state.deniedNotificationModalVisible }
                                    );
                                    backPressed();
                                }}>
                                <Text
                                    style={{
                                        // textAlign: 'center',
                                        color: 'blue',
                                        width: '100%',
                                    }}>
                                    Cancel
                    </Text>
                            </TouchableOpacity>
                        </View>
                    </View>
                </View>
            </Modal>
        );
    };

    render() {
        return (
            <View>
                <Text>NOTIFICATION GETTING...</Text>
                <Modal
                    animationType="slide"
                    transparent={true}
                    visible={this.state.modalVisible}
                    onRequestClose={() => {
                        // Alert.alert('Modal has been closed.');
                        this.setState({ modalVisible: !this.state.modalVisible });
                    }}>
                    <View style={styles.centeredView}>
                        <View style={styles.modalView}>
                            <View style={{ paddingHorizontal: 20, marginBottom: 20 }}>
                                <Text
                                    style={{
                                        color: 'grey',
                                        textAlign: 'center',
                                        fontWeight: 'bold',
                                        // fontFamily: fonts.Futura_Book_Font,
                                        fontSize: 20,
                                        marginBottom: 10,
                                    }}>
                                    jdbfbhvbewhbvws
                                </Text>
                                <Text
                                    style={{
                                        textAlign: 'center',
                                        color: 'grey',
                                        // fontFamily: fonts.Futura_Book_Font,
                                        fontSize: 16,
                                    }}>
                                    Notifications may include alerts, sounds, and icon badges. These
                                    can configured in Settings.
              </Text>
                            </View>
                            <View
                                style={{
                                    height: 0.5,
                                    width: '100%',
                                    backgroundColor: 'grey',
                                    opacity: 0.2,
                                }}
                            />
                            <View
                                style={{
                                    flexDirection: 'row',
                                    height: 60,
                                    width: '100%',
                                    alignItems: 'center',
                                    justifyContent: 'space-evenly',
                                }}>
                                <TouchableOpacity
                                    onPress={() => {
                                        setModalVisible(!modalVisible);
                                        // AsyncStorage.setItem('isNotificationAllow', 'false');
                                        check(PERMISSIONS.IOS.REMINDERS)
                                            .then(result => {
                                                switch (result) {
                                                    case RESULTS.UNAVAILABLE:
                                                        console.log(
                                                            'This feature is not available (on this device / in this context)',
                                                        );
                                                        break;
                                                    case RESULTS.DENIED:
                                                        console.log(
                                                            'The permission has not been requested / is denied but requestable',
                                                        );
                                                        break;
                                                    case RESULTS.LIMITED:
                                                        console.log(
                                                            'The permission is limited: some actions are possible',
                                                        );
                                                        break;
                                                    case RESULTS.GRANTED:
                                                        console.log('The permission is granted');
                                                        break;
                                                    case RESULTS.BLOCKED:
                                                        console.log(
                                                            'The permission is denied and not requestable anymore',
                                                        );
                                                        // backPressed();
                                                        this.setState({ deniedNotificationModalVisible: true });

                                                        // openSettings();
                                                        break;
                                                }
                                            })
                                            .catch(error => {
                                                // …
                                            });
                                    }}>
                                    <Text style={{ color: 'blue' }}>Don't allow</Text>
                                </TouchableOpacity>
                                <View
                                    style={{
                                        backgroundColor: 'grey',
                                        height: '100%',
                                        width: 1,
                                        opacity: 0.5,
                                    }}
                                />
                                <TouchableOpacity
                                    onPress={() => {
                                        setModalVisible(!modalVisible);
                                        // AsyncStorage.setItem('isNotificationAllow', 'true');
                                        requestNotifications(['alert', 'sound'])
                                            .then(({ status, settings }) => {
                                                console.log('statun n setting', status, '.', settings);
                                                // alert(status, 'setting', settings);

                                            })
                                            .catch(err =>
                                                console.log(
                                                    'req notification error',
                                                    JSON.stringify(err),
                                                ),
                                            );
                                        // props.navigation.navigate('NearByCafeScreen', {
                                        //   coords: location,
                                        // });
                                    }}>
                                    <Text
                                        style={{
                                            // textAlign: 'center',
                                            color: 'blue',
                                            width: '100%',
                                        }}>
                                        ALLOW
                                    </Text>
                                </TouchableOpacity>
                            </View>
                        </View>
                    </View>
                </Modal>
            </View>
        )
    }

}
export function trial() {
    console.log("Trial succeed...")
    return 'fnsngsgnsg'
}
export function requestNotification() {
    return requestNotifications(['alert', 'sound'])
        .then(({ status, settings }) => {
            //  alert('statun n setting'+ status + '.' + settings);
            if (status === 'granted') {
                getToken();
                //   AsyncStorage.setItem('isNotificationAllow', 'true');
                // props.navigation.navigate('NearByCafeScreen', {
                //   coords: location,
                // });
                console.log('granteddd')
            } else if (status === 'blocked') {
                // setDeniedNotificationModalVisible(true);
                // backPressed();
                // setDeniedNotificationModalVisible(
                //   !deniedNotificationModalVisible,
                // );
            }
            // alert(status, 'setting', settings);
        })
        .catch(err =>
            console.log('req notification error', JSON.stringify(err)),
        );
}
export function checkNotification() {
    checkNotifications().then(({ status, settings }) => {
        // alert('checked noti' + status + '.' + JSON.stringify(settings));
        console.log('checked noti', status, '.', settings);
        switch (status) {
            case RESULTS.UNAVAILABLE:
                console.log(
                    'This feature is not available (on this device / in this context)',
                );
                break;
            case RESULTS.DENIED:
                console.log(
                    'The permission has not been requested / is denied but requestable',
                );
                break;
            case RESULTS.LIMITED:
                console.log(
                    'The permission is limited: some actions are possible',
                );
                break;
            case RESULTS.GRANTED:
                console.log('The permission is granted');
                break;
            case RESULTS.BLOCKED:
                console.log(
                    'The permission is denied and not requestable anymore',
                );
                // setDeniedNotificationModalVisible(true);
                new GetNotification().state.deniedNotificationModalVisible = true
                // new GetNotification().setState({ deniedNotificationModalVisible: true })

                // openSettings();
                break;
        }
    })
};
export async function requestUserPermission() {
    const authStatus = await messaging().requestPermission();
    const enabled =
        authStatus === messaging.AuthorizationStatus.AUTHORIZED ||
        authStatus === messaging.AuthorizationStatus.PROVISIONAL;
    console.log('Authorization status:', authStatus);
    if (enabled) {
        if (authStatus === 1) {
            getToken();
            // AsyncStorage.setItem('isNotificationAllow', 'true');
            // props.navigation.navigate('NearByCafeScreen', {
            //   coords: location,
            // });

        }
    }
}
export async function getToken() {
    console.log("Get token called ==========================");
    Firebase.initializeApp();
    return PushNotification.configure({
        // (optional) Called when Token is generated (iOS and Android)
        onRegister: function (token) {
            console.log("Check for ios")
            if (Platform.OS == 'ios') {
                messaging().getToken().then(tokenn => {
                    console.log("Token==>", tokenn)
                    // AsyncStorage.setItem('FCMToken', JSON.stringify(tokenn))
                });

            } else {
                // AsyncStorage.setItem('FCMToken', JSON.stringify(token.token))
                console.log("TOKEN ==>", token)

            }
        },
        // (required) Called when a remote is received or opened, or local notification is opened
        onNotification: function (notification) {
            console.log('inside on notification', notification)
            notification.finish(PushNotificationIOS.FetchResult.NoData);

            if (Platform.OS == 'ios') {
                console.log('inside if block')
                return PushNotificationIOS.addNotificationRequest({
                    fireDate: new Date(Date.now() + (2 * 1000)).toISOString(),
                    title: notification.title,
                    body: notification.message,
                    sound: "Alarm.wav",
                    category: "userAction",
                    id: new Date().toString(),
                    repeats: "day"
                })
            } else {
                console.log('inside  notification else')
            }
        },

        // (optional) Called when Registered Action is pressed and invokeApp is false, if true onNotification will be called (Android)
        onAction: function (notification) {
            //console.log("ACTION:", notification.action);
            console.log("NOTIFICATION:=======>", notification);

            // process the action
        },

        // (optional) Called when the user fails to register for remote notifications. Typically occurs when APNS is having issues, or the device is a simulator. (iOS)
        onRegistrationError: function (err) {
            console.error('error in registration', err.message, err);
        },

        // IOS ONLY (optional): default: all - Permissions to register.
        permissions: {
            alert: true,
            badge: true,
            sound: true,
            "content-available": 1
        },


        popInitialNotification: true,

        requestPermissions: true,

    })
};

const styles = StyleSheet.create({
    centeredView: {
        flex: 1,
        padding: 44,
        justifyContent: 'center',
        alignItems: 'center',
        width: '100%',
    },
    modalView: {
        borderRadius: 10,
        backgroundColor: 'white',
        width: '100%',
        justifyContent: 'center',
        alignItems: 'center',
        marginTop: 20,
        marginBottom: 20,
        // margin: 20,
        paddingTop: 20,
        shadowColor: '#000',
        shadowOffset: {
            width: 0,
            height: 2,
        },
        shadowOpacity: 0.25,
        shadowRadius: 4,
    },
});